//+------------------------------------------------------------------+
//|                                                       Custom.mqh |
//|                                              Copyright 2010, Kos |
//|                                      http://mql5.com/ru/users/kos|
//+------------------------------------------------------------------+
#property copyright "2010,Kos"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CCustom
  {
public:
   bool              DataRange(int &Data[],int Value);
   bool              DataRange(ulong &Data[],ulong Value);
   bool              DataRange(double &Data[],double Value);
   bool              DataRange(uchar &Data[],uchar Value);
   bool              DataRange(string &Data[],string Value);
   uint              Low(int &Data[])    {return(0);}
   uint              High(int &Data[])   {return(ArraySize(Data)-1);}
   uint              Low(double &Data[]) {return(0);}
   uint              High(double &Data[]){return(ArraySize(Data)-1);}
   uint              Low(string &Data[]) {return(0);}
   uint              High(string &Data[]){return(ArraySize(Data)-1);}
   uint              Low(uchar &Data[])  {return(0);}
   uint              High(uchar &Data[]) {return(ArraySize(Data)-1);}
   uint              Low(ulong &Data[])  {return(0);}
   uint              High(ulong &Data[]) {return(ArraySize(Data)-1);}
   int               GetMax(int A,int B,int C);
   double            GetMax(double A,double B,double C);
   int               GetMin(int A,int B,int C);
   double            GetMin(double A,double B,double C);
   bool              Compare(int Value1,int Value2,double Template,uchar CompareType);
   bool              Compare(double Value1,double Value2,double Template,uchar CompareType);
   bool              InRange(int AValue,int AMin,int AMax);
   bool              InRange(double AValue,double AMin,double AMax);
   bool              IsTesting() {return(MQL5InfoInteger(MQL5_TESTING));}
   bool              IsTerminalTradeAllowed()    {return(TerminalInfoInteger(TERMINAL_TRADE_ALLOWED));}
   bool              IsAccountTradeAllowed()     {return(AccountInfoInteger(ACCOUNT_TRADE_ALLOWED));}
   bool              IsConnected()               {return(TerminalInfoInteger(TERMINAL_CONNECTED));}
   bool              IsExpertTradeAllowed()      {return(AccountInfoInteger(ACCOUNT_TRADE_EXPERT));}
   void              Printing(string Value,bool Use_Alert=false);
   void              FileCreate(string FName);
   int               CheckFile(string FName);
   double            Position(const double Begin,const double End,const double Price);
   string            TF(ENUM_TIMEFRAMES period);
protected:
   void              WriteTestingInfo(string Value);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool  CCustom::DataRange(int &Data[],int Value)
  {
   uint i;
   for(i=Low(Data);i<=High(Data);i++)
     {
      if(Value==Data[i]) return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool  CCustom::DataRange(ulong &Data[],ulong Value)
  {
   uint i;
   for(i=Low(Data);i<=High(Data);i++)
     {
      if(Value==Data[i]) return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool  CCustom::DataRange(double &Data[],double Value)
  {
   uint i;
   for(i=Low(Data);i<=High(Data);i++)
     {
      if(Value==Data[i]) return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool  CCustom::DataRange(uchar &Data[],uchar Value)
  {
   uint i;
   for(i=Low(Data);i<=High(Data);i++)
     {
      if(Value==Data[i]) return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool  CCustom::DataRange(string &Data[],string Value)
  {
   uint i;
   for(i=Low(Data);i<=High(Data);i++)
     {
      if(Value==Data[i]) return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int  CCustom::GetMax(int A,int B,int C)
  {
   return((int)MathMax(MathMax(A,B),MathMax(B,C)));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CCustom::GetMax(double A,double B,double C)
  {
   return((double)MathMax(MathMax(A,B),MathMax(B,C)));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int  CCustom::GetMin(int A,int B,int C)
  {
   return((int)MathMin(MathMin(A,B),MathMin(B,C)));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CCustom::GetMin(double A,double B,double C)
  {
   return((double)MathMin(MathMin(A,B),MathMin(B,C)));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool CCustom::Compare(int Value1,int Value2,double Template,uchar CompareType)
  {
   double result=0;
   if(Value1!=0 && Value2!=0)
     {
      switch(CompareType)
        {
         case 0:  // MORE
           {
            result=(double)Value1/Value2;
            if(result>=Template) return(true);
           }
         break;

         case 1:  //LESS
           {
            result=(double)Value1/Value2;
            if(result<=Template) return(true);
           }
         break;
         default: return(false);
        }
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool CCustom::Compare(double Value1,double Value2,double Template,uchar CompareType)
  {
   double result=0;
   if(Value1!=0 && Value2!=0)
     {
      switch(CompareType)
        {
         case 0:   //MORE
           {
            result=Value1/Value2;
            if(result>=Template) return(true);
           }
         break;

         case 1:   //LESS
           {
            result=Value1/Value2;
            if(result<=Template) return(true);
           }
         break;
         default: return(false);
        }
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool CCustom::InRange(int AValue,int AMin,int AMax)
  {
   if(AValue>=AMin && AValue<=AMax) return(true);
   else return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool CCustom::InRange(double AValue,double AMin,double AMax)
  {
   if(AValue>=AMin && AValue<=AMax) return(true);
   else return(false);
  }
//+------------------------------------------------------------------+
//|    ,       |
//+------------------------------------------------------------------+

void CCustom::Printing(string Value,bool Use_Alert=false)
  {
/*if(Use_Alert) Alert(Value);
         else Print(Value);*/
   if(!IsTesting())
     {
      if(Use_Alert) Alert(Value);
      else Print(Value);
     }
// else WriteTestingInfo(Value);
  }
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+

void CCustom::WriteTestingInfo(string Value)
  {
   string FName="Test.csv";
   int    handle;

   if(CheckFile(FName)==INVALID_HANDLE) FileCreate(FName);

   handle=FileOpen(FName,FILE_ANSI|FILE_WRITE|FILE_READ);
   if(handle!=INVALID_HANDLE)
     {
      FileSeek(handle,0,SEEK_END);
      FileWrite(handle,Value);
      FileClose(handle);
     }
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+

int CCustom::CheckFile(string FName)
  {
   int handle= FileOpen(FName,FILE_CSV|FILE_READ);
   if(handle ==INVALID_HANDLE)
     {
      Print("File:",FName," error "+DoubleToString(GetLastError(),0));
      return(-1);
     }
   else
     {
      FileClose(handle);
      return(1);
     }
  }
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+

void CCustom::FileCreate(string FName)
  {
   int handle=FileOpen(FName,FILE_CSV|FILE_WRITE);
   if(handle>0) Print("FILE: "+FName+" was create");
   FileClose(handle);
  }
//+------------------------------------------------------------------+
//|  Price        |
//|Begin,End.   %   Begin              |
//+------------------------------------------------------------------+
double CCustom::Position(const double Begin,const double End,const double Price)
  {
   double Length=0;
   double Width=0;
   double Pos=-100;

   if(Begin>0 && End>0 && Price>0)
     {
      if(Begin<End)
        {
         Length =Price-Begin;
         Width  =End-Begin;
        }
      else
        {
         Length=Begin-Price;
         Width =Begin-End;
        }
      if(Length!=0 && Width!=0) Pos=NormalizeDouble(Length/Width,2)*100;
     }
   return(Pos);
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+

string CCustom::TF(ENUM_TIMEFRAMES period)
  {
   if(period==PERIOD_CURRENT) period=Period();
//---
   switch(period)
     {
      case PERIOD_M1:  return(": M1");
      case PERIOD_M2:  return(": M2");
      case PERIOD_M3:  return(": M3");
      case PERIOD_M4:  return(": M4");
      case PERIOD_M5:  return(": M5");
      case PERIOD_M6:  return(": M6");
      case PERIOD_M10: return(": M10");
      case PERIOD_M12: return(": M12");
      case PERIOD_M15: return(": M15");
      case PERIOD_M20: return(": M20");
      case PERIOD_M30: return(": M30");
      case PERIOD_H1:  return(": H1");
      case PERIOD_H2:  return(": H2");
      case PERIOD_H3:  return(": H3");
      case PERIOD_H4:  return(": H4");
      case PERIOD_H6:  return(": H6");
      case PERIOD_H8:  return(": H8");
      case PERIOD_H12: return(": H12");
      case PERIOD_D1:  return(": Daily");
      case PERIOD_W1:  return(": Weekly");
      case PERIOD_MN1: return(": Monthly");
     }
//---
   return("unknown period");
  }
//+------------------------------------------------------------------+
