//+------------------------------------------------------------------+
//|                                                          ERP.mqh |
//|                                              Copyright 2010, Kos |
//|                                      http://mql5.com/ru/users/kos|
//+------------------------------------------------------------------+
#property copyright "2010,Kos"

#include <Trade\SymbolInfo.mqh>

input    double HW            = 0.8;
input    double Crow          = 0.8;
input    double Harami        = 0.2;
input    double Doji          = 0.1;
input    double GAP           = 1;
input    double Error         = 0.05;
input    int    Shades        = 3;
input    int    Shades_pin    = 3;
input    int    Body          = 3;
input    int    Body_pin      = 3;
input    int    Body_HW       = 2;
//---
input    float  LB            = 0.8;
input    float  LB_Lines      = 0.8;
input    float  LB_Crows      = 0.8;
input    bool   Use_Targets   = true;
//---
input    uchar  Expired_Time_Shift=3;                          // " "( )

input    bool   ShootingStar  = true;
input    bool   HangingMan    = true;
input    bool   Hammer        = true;
input    bool   InvertedHammer= true;
input    bool   ThreeOutside  = true;
input    bool   ThreeInside   = true;
input    bool   Engulfing     = true;
input    bool   LastEngulfing = true;
input    bool   BeltHold      = true;
input    bool   Stars         = true;
input    bool   Crows         = true;
input    bool   DarkCloud     = true;
input    bool   PiercingLine  = true;
input    bool   ThrustingLine = true;
input    bool   OnNeckLine    = true;
input    bool   InNeckLine    = true;
input    bool   MeetingLine   = true;
input    bool   AdvanceBlock  = true;
input    bool   Deliberation  = true;
input    bool   Soldiers      = true;
input    bool   HomingPiegon  = true;
input    bool   PinBar        = true;
//+------------------------------------------------------------------+

//--- 
enum ENUM_ERP_TYPE
  {
   ERP_CANDLE=0,                                            // 1- 
   ERP_PATTERN=1,                                           // 2- 
   ERP_GROUP=2                                              // 3- 
  };
//--- 
enum ENUM_ERP_SIGNAL
  {
   ERP_NO_SIGNAL=0,
   ERP_SHORT_SIGNAL=1,
   ERP_LONG_SIGNAL=2,
   ERP_SHORT_CONTINUE_SIGNAL=3,
   ERP_LONG_CONTINUE_SIGNAL=4
  };
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
struct EngineResult
  {
   double            OpenTarget;                            //  
   double            StopTarget;                            //     
   datetime          TimeOpen;                              //     
   ushort            UID;                                   //  
   ENUM_ERP_SIGNAL   TypeSignal;                            //  Sell,Buy,ContinueSell,ContinueBuy
  };
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
class CJCPEngine
  {
private:
   //+------------------------------------------------------------------+
   //|                                             |
   //+------------------------------------------------------------------+
   struct   EngineSettings
     {
      double            ES_HW;
      double            ES_Crows;
      double            ES_Harami;
      double            ES_Doji;
      double            ES_GAP;
      double            ES_Error;
      float             ES_LB;
      float             ES_LB_Lines;
      float             ES_LB_Crows;
      int               ES_Shades;
      int               ES_Shades_pin;
      int               ES_Body;
      int               ES_Body_pin;
      int               ES_Body_HW;
      bool              ES_Get_Targets;
     };
   //+------------------------------------------------------------------+
   //|                                       |
   //+------------------------------------------------------------------+
   struct   IncludePatterns
     {
      bool              UseShootingStar;
      bool              UseHangingMan;
      bool              UseHammer;
      bool              UseInvertedHammer;
      bool              UseThreeOutside;
      bool              UseThreeInside;
      bool              UseEngulfing;
      bool              UseLastEngulfing;
      bool              UseBeltHold;
      bool              UseStars;
      bool              UseCrows;
      bool              UseDarkCloud;
      bool              UsePiercingLine;
      bool              UseThrustingLine;
      bool              UseOnNeckLine;
      bool              UseInNeckLine;
      bool              UseMeetingLine;
      bool              UseAdvanceBlock;
      bool              UseDeliberation;
      bool              UseSoldiers;
      bool              UseHomingPiegon;
      bool              UsePinBar;
     };
   IncludePatterns   UsesPatterns;
   EngineSettings    Settings;
public:
   bool              Init(void);
  };

#import "JCPEngine.ex5";
bool   EngineInit(IncludePatterns &Data,EngineSettings &Data);
#import
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
bool CJCPEngine::Init()
  {
   Settings.ES_HW                 =HW;
   Settings.ES_Crows              =Crow;
   Settings.ES_Harami             =Harami;
   Settings.ES_Doji               =Doji;
   Settings.ES_GAP                =GAP;
   Settings.ES_Error              =Error;
   Settings.ES_Shades             =Shades;
   Settings.ES_Shades_pin         =Shades_pin;
   Settings.ES_Body               =Body;
   Settings.ES_Body_pin           =Body_pin;
   Settings.ES_Body_HW            =Body_HW;
   Settings.ES_LB                 =LB;
   Settings.ES_LB_Lines           =LB_Lines;
   Settings.ES_LB_Crows           =LB_Crows;
   Settings.ES_Get_Targets        =Use_Targets;
//---
   UsesPatterns.UseShootingStar   =ShootingStar;
   UsesPatterns.UseHangingMan     =HangingMan;
   UsesPatterns.UseHammer         =Hammer;
   UsesPatterns.UseInvertedHammer =InvertedHammer;
   UsesPatterns.UseThreeOutside   =ThreeOutside;
   UsesPatterns.UseThreeInside    =ThreeInside;
   UsesPatterns.UseEngulfing      =Engulfing;
   UsesPatterns.UseLastEngulfing  =LastEngulfing;
   UsesPatterns.UseBeltHold       =BeltHold;
   UsesPatterns.UseStars          =Stars;
   UsesPatterns.UseCrows          =Crows;
   UsesPatterns.UseDarkCloud      =DarkCloud;
   UsesPatterns.UsePiercingLine   =PiercingLine;
   UsesPatterns.UseThrustingLine  =ThrustingLine;
   UsesPatterns.UseOnNeckLine     =OnNeckLine;
   UsesPatterns.UseInNeckLine     =InNeckLine;
   UsesPatterns.UseMeetingLine    =MeetingLine;
   UsesPatterns.UseAdvanceBlock   =AdvanceBlock;
   UsesPatterns.UseDeliberation   =Deliberation;
   UsesPatterns.UseSoldiers       =Soldiers;
   UsesPatterns.UseHomingPiegon   =HomingPiegon;
   UsesPatterns.UsePinBar         =PinBar;
   return(EngineInit(UsesPatterns,Settings));
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
class CEngineManager
  {
protected:
   CSymbolInfo      *Info;
   EngineResult      ERP[3];                                   //      ( )
public:
                     CEngineManager();
   bool              EngineRUN(ENUM_TIMEFRAMES TimeFrame,CSymbolInfo *CInfo);
   bool              fgCandle;                                 //   1- 
   bool              fgPattern;                                //   2- 
   bool              fgGroup;                                  //   3- 
   double            GetOpenTarget(ENUM_ERP_TYPE TypeModel) const   {return((double)ERP[TypeModel].OpenTarget);}
   double            GetStopTarget(ENUM_ERP_TYPE TypeModel) const   {return((double)ERP[TypeModel].StopTarget);}
   datetime          GetTimeStamp(ENUM_ERP_TYPE TypeModel)  const   {return((datetime)ERP[TypeModel].TimeOpen);}
   uint              GetUID(ENUM_ERP_TYPE TypeModel)        const   {return((uint)ERP[TypeModel].UID);}
   ENUM_ERP_SIGNAL   GetTypeSignal(ENUM_ERP_TYPE TypeModel) const   {return((ENUM_ERP_SIGNAL)ERP[TypeModel].TypeSignal);}
   void              GetERPStruc(ENUM_ERP_TYPE TypeModel,EngineResult &Query);
  };

#import "JCPEngine.ex5";
uchar  EngineExecution(ENUM_TIMEFRAMES TimeFrame,EngineResult &Data[],CSymbolInfo &Info);
string GetCandleCaption(int id,int LangID);
string GetPatternCaption(int id,int LangID);
#import
//+------------------------------------------------------------------+
//|                                                       |
//+------------------------------------------------------------------+

CEngineManager::CEngineManager(void)
  {
   Info=NULL;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

bool CEngineManager::EngineRUN(ENUM_TIMEFRAMES TimeFrame,CSymbolInfo *CInfo)
  {
   bool result =false;
   fgCandle    =false;
   fgPattern   =false;
   fgGroup     =false;
   if((Info=CInfo)!=NULL)
     {
      uchar ER=EngineExecution(TimeFrame,ERP,Info);
      if(ER>0)
        {
         fgCandle  =(ER==1 || ER==3 || ER==5 || ER==7);
         fgPattern =(ER==2 || ER==3 || ER==6 || ER==7);
         fgGroup   =(ER==4 || ER==5 || ER==6 || ER==7);
         result=true;
         Print(ER);
        }
     }
   return(result);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CEngineManager::GetERPStruc(ENUM_ERP_TYPE TypeModel,EngineResult &Query)
  {
   Query.OpenTarget=ERP[TypeModel].OpenTarget;
   Query.StopTarget=ERP[TypeModel].StopTarget;
   Query.TimeOpen  =ERP[TypeModel].TimeOpen;
   Query.UID       =ERP[TypeModel].UID;
   Query.TypeSignal=ERP[TypeModel].TypeSignal;
  }
//+------------------------------------------------------------------+
