//+------------------------------------------------------------------+
//|                                                      Targets.mqh |
//|                                              Copyright 2010, Kos |
//|                                      http://mql5.com/ru/users/kos|
//+------------------------------------------------------------------+
#property copyright "2010,Kos"

#include <JCPE\Var.mqh>
#include <JCPE\Candle.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CTargets
  {
private:
protected:
   CCandle          *Candle;
public:
                     CTargets(void);
   bool              Init(CCandle *objCandle);
   double            GetOpenTarget(ushort id);
   double            GetStopTarget(ushort id);
  };
//+------------------------------------------------------------------+

CTargets::CTargets(void)
  {
   Candle=NULL;
  }
//+------------------------------------------------------------------+

bool CTargets::Init(CCandle *objCandle)
  {
   return((Candle=objCandle)!=NULL);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|   StopLoss               |
//+------------------------------------------------------------------+

double CTargets::GetStopTarget(ushort id)
  {
   double distance=2*Stops*point;
   double SL=0;

// -

   if(id==11 || id==22)
     {
      SL=(id==22)?Candle.Lo(1)-distance : Candle.Hi(1)+distance;
      return(NormalizeDouble(SL,digits));
     }

//  ,  

   if((id>4000 && id<5000) || (id>1000 && id<2000))
     {
      SL=NormalizeDouble(MathMax(MathMax(Candle.Hi(1),Candle.Hi(2)),MathMax(Candle.Hi(2),Candle.Hi(3))),digits)+distance;
      return(SL);
     }

// ,  

   if(id>2000 && id<4000)
     {
      SL=NormalizeDouble(MathMin(MathMin(Candle.Lo(1),Candle.Lo(2)),MathMin(Candle.Lo(2),Candle.Lo(3))),digits)-distance;
      return(SL);
     }
//  , , ,    , -   

   if(id>5000 && id<6000)
     {
      if((id!=5005) || (id!=5505))
        {
         SL=NormalizeDouble(MathMax(MathMax(Candle.Hi(1),Candle.Hi(2)),MathMax(Candle.Hi(2),Candle.Hi(3))),digits)+distance;
        }
      else
        {
         SL=NormalizeDouble(MathMax(Candle.Hi(1),Candle.Hi(2)),digits)+distance;
        }
      return(SL);
     }
   if(id>6000 && id<7000)
     {
      if((id!=6005) || (id!=6505))
        {
         SL=NormalizeDouble(MathMin(MathMin(Candle.Lo(1),Candle.Lo(2)),MathMin(Candle.Lo(2),Candle.Lo(3))),digits)+distance;
        }
      else
        {
         SL=NormalizeDouble(MathMin(Candle.Lo(1),Candle.Lo(2)),digits)+distance;
        }
      return(SL);
     }
//    /,""  

   if(id<1000)
     {
      if(Custom.DataRange(insidedown,id))
        {
         SL=NormalizeDouble(MathMax(MathMax(Candle.Hi(1),Candle.Hi(2)),MathMax(Candle.Hi(2),Candle.Hi(3))),digits)+distance;
        }
      else
        {
         if(Custom.DataRange(insideup,id))
           {
            SL=NormalizeDouble(MathMin(MathMin(Candle.Lo(1),Candle.Lo(2)),MathMin(Candle.Lo(2),Candle.Lo(3))),digits)-distance;
           }
        }
      return(SL);
     }
//   /,  

   if(id>=9000 && id<10000)
     {
      if(Custom.DataRange(outsidedown,id))
        {
         SL=NormalizeDouble(MathMax(MathMax(Candle.Hi(1),Candle.Hi(2)),MathMax(Candle.Hi(2),Candle.Hi(3))),digits)+distance;
        }
      else
        {
         if(Custom.DataRange(outsideup,id))
           {
            SL=NormalizeDouble(MathMin(MathMin(Candle.Lo(1),Candle.Lo(2)),MathMin(Candle.Lo(2),Candle.Lo(3))),digits)-distance;
           }
        }
      return(SL);
     }
   
//    ,"  ","  "

   if(id>7000 && id<8000)
     {
      SL=NormalizeDouble(MathMax(MathMax(Candle.Hi(1),Candle.Hi(2)),MathMax(Candle.Hi(2),Candle.Hi(3))),digits)+distance;
     }
   else
     {
      if(id>8000 && id<9000)
        {
         if(!Custom.DataRange(BearContinuation,id))
           {
            SL=NormalizeDouble(MathMin(MathMin(Candle.Lo(1),Candle.Lo(2)),MathMin(Candle.Lo(2),Candle.Lo(3))),digits)-distance;
           }
         else
           {
            SL=NormalizeDouble(MathMax(MathMax(Candle.Hi(1),Candle.Hi(2)),MathMax(Candle.Hi(2),Candle.Hi(3))),digits)+distance;
           }
        }
      return(SL);
     }

   return(SL);
  }
//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+

double CTargets::GetOpenTarget(ushort id)
  {
   double distance=Stops*point;;
   double OP=0;
// -

   if(id==11 || id==22)
     {
      OP=(id==22)?Candle.Hi(1)+distance : Candle.Lo(1)-distance;
      return(NormalizeDouble(OP,digits));
     }

//  ,o     
   if((id>4000 && id<5000) || (id>1000 && id<2000))
     {
      if(Candle.LongCandle(3,Settings.ES_LB))
        {
         OP=Candle.Lo(1)-distance;
         OP=(Candle.Lo(3)<OP) ? Candle.Lo(3) : OP;
         return(NormalizeDouble(OP,digits));
        }
      return(NormalizeDouble(Candle.Lo(1),digits)-distance);
     }

// ,  

   if(id>2000 && id<4000)
     {
      if(Candle.LongCandle(3,Settings.ES_LB))
        {
         OP=Candle.Hi(1)+distance;
         OP=(Candle.Hi(3)>OP) ? Candle.Hi(3) : OP;
         return(NormalizeDouble(OP,digits));
        }
      return(NormalizeDouble(Candle.Hi(1),digits)+distance);
     }

//  , , ,    , -   

   if(id>5000 && id<6000)
     {
      if(Candle.LongCandle(3,Settings.ES_LB))
        {
         OP=Candle.Lo(1)-distance;
         OP=(Candle.Lo(3)<OP) ? Candle.Lo(3) : OP;
         return(NormalizeDouble(OP,digits));
        }
      return(NormalizeDouble(Candle.Lo(1),digits)-distance);
     }
   if(id>6000 && id<7000)
     {
      if(Candle.LongCandle(3,Settings.ES_LB))
        {
         OP=Candle.Hi(1)+distance;
         OP=(Candle.Hi(3)>OP) ? Candle.Hi(3) : OP;
         return(NormalizeDouble(OP,digits));
        }
      return(NormalizeDouble(Candle.Hi(1),digits)+distance);
     }
//    /,""  

   if(id<1000)
     {
      if(Custom.DataRange(insidedown,id))
        {
         if(Candle.LongCandle(3,Settings.ES_LB))
           {
            OP=Candle.Lo(1)-distance;
            OP=(Candle.Lo(3)<OP) ? Candle.Lo(3) : OP;
            return(NormalizeDouble(OP,digits));
           }
         return(NormalizeDouble(Candle.Lo(1),digits)-distance);
        }
      else
        {
         if(Custom.DataRange(insideup,id))
           {
            if(Candle.LongCandle(3,Settings.ES_LB))
              {
               OP=Candle.Hi(1)+distance;
               OP=(Candle.Hi(3)>OP) ? Candle.Hi(3) : OP;
               return(NormalizeDouble(OP,digits));
              }
            return(NormalizeDouble(Candle.Hi(1),digits)+distance);
           }
        }

     }
//   /,  

   if(id>=9000 && id<10000)
     {
      if(Custom.DataRange(outsidedown,id))
        {
         return(NormalizeDouble(Candle.Lo(1),digits)-distance);
        }
      else
        {
         if(Custom.DataRange(outsideup,id))
           {
            return(NormalizeDouble(Candle.Hi(1),digits)+distance);
           }
        }

     }
   
    
//    ,"  ","  "

   if(id>7000 && id<8000)
     {
      if(Candle.LongCandle(3,Settings.ES_LB_Lines))
        {
         OP= Candle.Lo(1)-distance;
         OP=(Candle.Lo(3)<OP) ? Candle.Lo(3) : OP;
         return(NormalizeDouble(OP,digits));
        }
      return(NormalizeDouble(Candle.Lo(1),digits)-distance);
     }
   else
     {
      if(id>8000 && id<9000)
        {
         if(!Custom.DataRange(BearContinuation,id))
           {
            if(Candle.LongCandle(3,Settings.ES_LB_Lines))
              {
               OP=Candle.Hi(1)+distance;
               OP=(Candle.Hi(3)>OP) ? Candle.Hi(3) : OP;
               return(NormalizeDouble(OP,digits));
              }
            return(NormalizeDouble(Candle.Hi(1),digits)+distance);
           }
         else
           {
            return(NormalizeDouble(Candle.Lo(1),digits)-distance);
           }
        }

     }

   return(OP);
  }