//+------------------------------------------------------------------+
//|                                                          Var.mqh |
//|                                              Copyright 2010, Kos |
//|                              https://login.mql5.com/ru/users/kos |
//+------------------------------------------------------------------+
#property copyright "2010,Kos"

#include <JCPE\Custom.mqh>
#include <JCPE\Loader.mqh>
#include <JCPE\Const.mqh>

int    insidedown[8]       ={60,70,80,90,560,570,580,590};
int    insideup[8]         ={110,120,130,140,610,620,630,640};
int    outsidedown[8]      ={9000,9500,9400,9401,9402,9900,9901,9902};
int    outsideup[8]        ={9100,9600,9450,9451,9452,9950,9951,9952};
int    BearContinuation[9] ={8060,8063,8064,8070,8073,8074,8080,8083,8084};

int EngulfingArray[52]=
  {
   203,303,703,803,
   204,304,704,804,
   205,305,705,805,
   206,306,706,806,
   214,714,264,764,
   215,715,265,765,
   216,716,266,766,
   224,724,274,774,
   225,725,275,775,
   226,726,276,776,
   244,744,294,794,
   245,745,295,795,
   246,746,296,796
  };
/*
int StarsArray[48]=
  {
   1004,1104,1504,1604,
   2004,2104,2504,2604,
   3004,3104,3504,3604,
   4004,4104,4504,4604,
   1005,1105,1505,1605,
   2005,2105,2505,2605,
   3005,3105,3505,3605,
   4005,4105,4505,4605,
   1006,1106,1506,1606,
   2006,2106,2506,2606,
   3006,3106,3506,3606,
   4006,4106,4506,4606
  };*/
int    StarsArray[16] = {1006,1106,1506,1606,
                         2006,2106,2506,2606,
                         3006,3106,3506,3606,
                         4006,4106,4506,4606};
CCustom               Custom;

//--- 
enum ENUM_ERP_TYPE
  {
   ERP_CANDLE=0,                                            // 1- 
   ERP_PATTERN=1,                                           // 2- 
   ERP_GROUP=2                                              // 3- 
  };
  
//--- 
enum ENUM_ERP_SIGNAL
  {
   ERP_NO_SIGNAL=0,
   ERP_SHORT_SIGNAL=1,
   ERP_LONG_SIGNAL=2,
   ERP_SHORT_CONTINUE_SIGNAL=3,
   ERP_LONG_CONTINUE_SIGNAL=4
  };
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct   EngineSettings
  {
   double            ES_HW;
   double            ES_Crows;
   double            ES_Harami;
   double            ES_Doji;
   double            ES_GAP;
   double            ES_Error;
   float             ES_LB;
   float             ES_LB_Lines;
   float             ES_LB_Crows;
   int               ES_Shades;
   int               ES_Shades_pin;
   int               ES_Body;
   int               ES_Body_pin;
   int               ES_Body_HW;
   bool              ES_Get_Targets;
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct   IncludePatterns
  {
   bool              UseShootingStar;
   bool              UseHangingMan;
   bool              UseHammer;
   bool              UseInvertedHammer;
   bool              UseThreeOutside;
   bool              UseThreeInside;
   bool              UseEngulfing;
   bool              UseLastEngulfing;
   bool              UseBeltHold;
   bool              UseStars;
   bool              UseCrows;
   bool              UseDarkCloud;
   bool              UsePiercingLine;
   bool              UseThrustingLine;
   bool              UseOnNeckLine;
   bool              UseInNeckLine;
   bool              UseMeetingLine;
   bool              UseAdvanceBlock;
   bool              UseDeliberation;
   bool              UseSoldiers;
   bool              UseHomingPiegon;
   bool              UsePinBar;
  };

struct EngineResult
  {
   double            OpenTarget;            //  
   double            StopTarget;            //     
   datetime          TimeOpen;              //      
   ushort            UID;                   //  
   ENUM_ERP_SIGNAL   TypeSignal;            //  Sell,Buy,ContinueSell,ContinueBuy
  };

IncludePatterns  UsesPatterns;
EngineSettings   Settings;
EngineResult     EngResult[3];

int    CountCandles;
string Name;
int    digits;
double point;
int    Stops;

double GGap,GDoji,pips,G_Error;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void StructClean(EngineResult &Data[])
  {
   for(int i=0;i<3;i++)
     {
      Data[i].OpenTarget        =0.0;
      Data[i].StopTarget        =0.0;
      Data[i].TimeOpen          =0;
      Data[i].TypeSignal        =ERP_NO_SIGNAL;
      Data[i].UID               =0;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void StructClean(EngineSettings &Data)
  {
   Data.ES_Body           =0;
   Data.ES_Body_HW        =0;
   Data.ES_Body_pin       =0;
   Data.ES_Crows          =0;
   Data.ES_Doji           =0;
   Data.ES_Error          =0;
   Data.ES_GAP            =0;
   Data.ES_HW             =0;
   Data.ES_Harami         =0;
   Data.ES_LB             =0;
   Data.ES_LB_Crows       =0;
   Data.ES_LB_Lines       =0;
   Data.ES_Shades         =0;
   Data.ES_Shades_pin     =0;
   Data.ES_Get_Targets    =0;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void StructClean(IncludePatterns &Data)
  {
   Data.UseShootingStar   =false;
   Data.UseHangingMan     =false;
   //Data.UseHammer         =false;
   //Data.UseInvertedHammer =false;
   Data.UseThreeOutside   =false;
   Data.UseThreeInside    =false;
   Data.UseEngulfing      =false;
   Data.UseLastEngulfing  =false;
   Data.UseBeltHold       =false;
   Data.UseStars          =false;
   Data.UseCrows          =false;
   Data.UseDarkCloud      =false;
   //Data.UsePiercingLine   =false;
   //Data.UseThrustingLine  =false;
   //Data.UseOnNeckLine     =false;
   //Data.UseInNeckLine     =false;
   //Data.UseMeetingLine    =false;
   Data.UseAdvanceBlock   =false;
   //Data.UseDeliberation   =false;
   //Data.UseSoldiers       =false;
  // Data.UseHomingPiegon   =false;
   //Data.UsePinBar         =false;
  }
//+------------------------------------------------------------------+
