//+------------------------------------------------------------------+
//|                                                        JCPDS.mq5 |
//|                                              Copyright 2010, Kos |
//|                              https://login.mql5.com/ru/users/kos |
//+------------------------------------------------------------------+
#property library
#property copyright "2010,Kos"
#property link "https://login.mql5.com/ru/users/kos"
#property version   "1.00"

#include <JCPE\Var.mqh>
#include <JCPE\Candle.mqh>
#include <JCPE\JCPE.mqh>
#include <JCPE\Captions.mqh>
#include <JCPE\Targets.mqh>
#include <Trade\SymbolInfo.mqh>

CCandle  *Candle;
CEngine  *Engine;
CTargets *Targets;
CSymbolInfo *Info;
bool              EngineActivated   =false;
ENUM_ERP_SIGNAL   CandleSignalType  =ERP_NO_SIGNAL;
ENUM_ERP_SIGNAL   PatternSignalType =ERP_NO_SIGNAL;
ENUM_ERP_SIGNAL   GroupSignalType   =ERP_NO_SIGNAL;
ushort            Candle_ID         =0;
ushort            Pattern_ID        =0;
ushort            Group_ID          =0;
datetime          TimeExecution     =0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int EngineExecution(ENUM_TIMEFRAMES TimeFrame,int History_Point,EngineResult &Data[],string f_Symbol) export
  {
   uchar result=0;
   char  ER=0;
   datetime Time[1];
   if((Info=new CSymbolInfo)==NULL && !EngineActivated) return(result);
   Info.Name(f_Symbol);
   Name    =f_Symbol;
   digits  =(int)Info.Digits();
   point   =(double)Info.Point();
   Stops   =(int)Info.StopsLevel();
   if((Candle=new CCandle)==NULL) return(0);
   CountCandles=Candle.SetRates(TimeFrame,Name,History_Point);
   if(CountCandles>0)
     {
      Engine=new CEngine;
      ER=(char)Engine.EngineCalculate(Candle);
      if(ER>0)
        {
         if(CopyTime(Name,TimeFrame,History_Point,1,Time)>0) TimeExecution=(datetime)Time[0]-PeriodSeconds(TimeFrame);
         Targets=new CTargets;
         StructClean(EngResult);
         result=ER;
         switch(ER)
           {
            case 1:
               ER_Candle();
               SetResult(ERP_CANDLE);
               break;

            case 2:
               ER_Pattern();
               SetResult(ERP_PATTERN);
               break;

            case 3:
               ER_Candle();
               SetResult(ERP_CANDLE);
               ER_Pattern();
               SetResult(ERP_PATTERN);
               break;

            case 4:
               ER_Group();
               SetResult(ERP_GROUP);
               break;

            case 5:
               ER_Candle();
               SetResult(ERP_CANDLE);
               ER_Group();
               SetResult(ERP_GROUP);
               break;

            case 6:
               ER_Pattern();
               SetResult(ERP_PATTERN);
               ER_Group();
               SetResult(ERP_GROUP);
               break;

            case 7:
               ER_Candle();
               SetResult(ERP_CANDLE);
               ER_Pattern();
               SetResult(ERP_PATTERN);
               ER_Group();
               SetResult(ERP_GROUP);
               break;
           }
         
         for(int i=0;i<3;i++)
          {
           Data[i].OpenTarget=EngResult[i].OpenTarget;
           Data[i].StopTarget=EngResult[i].StopTarget;
           Data[i].TimeOpen  =EngResult[i].TimeOpen;
           Data[i].UID       =EngResult[i].UID;
           Data[i].TypeSignal=EngResult[i].TypeSignal;           
          }
         delete Targets;
        }
      delete Engine;
     }
   delete Candle; Candle=NULL;
   delete Info; Info=NULL;
   return(result);
  }
//+------------------------------------------------------------------+  

//+------------------------------------------------------------------+
//|  :  UID          |
//+------------------------------------------------------------------+
void ER_Candle()
  {
   Candle_ID=Engine.Get_Candle_Code();
   CandleSignalType=Engine.GetTypeSignal(Candle_ID);
  }
  
//+------------------------------------------------------------------+
//|  :  UID,,  |
//|                           |
//+------------------------------------------------------------------+
void ER_Pattern()
  {
   Pattern_ID=Engine.Get_Pattern_Code();
   PatternSignalType=Engine.GetTypeSignal(Pattern_ID);
  }
  
//+------------------------------------------------------------------+
//|  :  UID,,  |
//|                           |
//+------------------------------------------------------------------+
void ER_Group()
  {
   Group_ID=Engine.Get_Group_Code();
   GroupSignalType=Engine.GetTypeSignal(Group_ID);
  }
  
//+------------------------------------------------------------------+
//| ERP                                             |
//+------------------------------------------------------------------+
void SetResult(ENUM_ERP_TYPE id)
  {
   ENUM_ERP_SIGNAL  Signal_type=ERP_NO_SIGNAL;
   ushort uid=0;

   switch(id)
     {
      case ERP_CANDLE:
        {
         //Signal_type=CandleSignalType;
         uid=Candle_ID;
        }
      break;

      case ERP_PATTERN:
        {
         Signal_type=PatternSignalType;
         uid=Pattern_ID;
        }
      break;

      case ERP_GROUP:
        {
         Signal_type=GroupSignalType;
         uid=Group_ID;
        }
      break;
     }
   Save(id,Signal_type,uid); 
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Save(const ENUM_ERP_TYPE id,const ENUM_ERP_SIGNAL ST,const ushort UI)
  {
   EngResult[id].UID           =UI;
   EngResult[id].TypeSignal    =ST;
   if(Settings.ES_Get_Targets)
     {
      Targets.Init(Candle);
      EngResult[id].StopTarget =Targets.GetStopTarget(UI);
      EngResult[id].OpenTarget =Targets.GetOpenTarget(UI);
     }
   EngResult[id].TimeOpen=TimeExecution;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string GetCandleCaption(int id,int LangID) export
  {
   return(CandleDesc(id,LangID));
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string GetPatternCaption(int id,int LangID) export
  {
   return(PatternDesc(id,LangID));
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool EngineInit(IncludePatterns &Patterns,EngineSettings &ES) export
  {
   Settings.ES_HW                 =ES.ES_HW;
   Settings.ES_Crows              =ES.ES_Crows;
   Settings.ES_Harami             =ES.ES_Harami;
   Settings.ES_Doji               =ES.ES_Doji;
   Settings.ES_GAP                =ES.ES_GAP;
   Settings.ES_Error              =ES.ES_Error;
   Settings.ES_Shades             =ES.ES_Shades;
   Settings.ES_Shades_pin         =ES.ES_Shades_pin;
   Settings.ES_Body               =ES.ES_Body;
   Settings.ES_Body_pin           =ES.ES_Body_pin;
   Settings.ES_Body_HW            =ES.ES_Body_HW;
   Settings.ES_LB                 =ES.ES_LB;
   Settings.ES_LB_Lines           =ES.ES_LB_Lines;
   Settings.ES_LB_Crows           =ES.ES_LB_Crows;
   Settings.ES_Get_Targets        =ES.ES_Get_Targets;
//---
   UsesPatterns.UseShootingStar   =Patterns.UseShootingStar;
   UsesPatterns.UseHangingMan     =Patterns.UseHangingMan;
   UsesPatterns.UseHammer         =Patterns.UseHammer;
   UsesPatterns.UseInvertedHammer =Patterns.UseInvertedHammer;
   UsesPatterns.UseThreeOutside   =Patterns.UseThreeOutside;
   UsesPatterns.UseThreeInside    =Patterns.UseThreeInside;
   UsesPatterns.UseEngulfing      =Patterns.UseEngulfing;
   UsesPatterns.UseLastEngulfing  =Patterns.UseLastEngulfing;
   UsesPatterns.UseBeltHold       =Patterns.UseBeltHold;
   UsesPatterns.UseStars          =Patterns.UseStars;
   UsesPatterns.UseCrows          =Patterns.UseCrows;
   UsesPatterns.UseDarkCloud      =Patterns.UseDarkCloud;
   UsesPatterns.UsePiercingLine   =Patterns.UsePiercingLine;
   UsesPatterns.UseThrustingLine  =Patterns.UseThrustingLine;
   UsesPatterns.UseOnNeckLine     =Patterns.UseOnNeckLine;
   UsesPatterns.UseInNeckLine     =Patterns.UseInNeckLine;
   UsesPatterns.UseMeetingLine    =Patterns.UseMeetingLine;
   UsesPatterns.UseAdvanceBlock   =Patterns.UseAdvanceBlock;
   UsesPatterns.UseDeliberation   =Patterns.UseDeliberation;
   UsesPatterns.UseSoldiers       =Patterns.UseSoldiers;
   UsesPatterns.UseHomingPiegon   =Patterns.UseHomingPiegon;
   UsesPatterns.UsePinBar         =Patterns.UsePinBar;
   return((EngineActivated=true));
  }
//+------------------------------------------------------------------+
